package marvel.centralsmashdown
{
   import com.chris.AS3.net.FlashVars;
   import com.gs.TweenLite;
   import com.markdavies.debug.DebugBox;
   import com.markdavies.events.CustomEvent;
   import com.markdavies.net.Preloader;
   import com.markdavies.sound.SoundCollection;
   import com.soap.net.MarvelLoginUser;
   import com.soap.net.Mochi;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.media.*;
   import flash.net.*;
   import flash.system.*;
   import flash.ui.*;
   import marvel.centralsmashdown.game.*;
   import marvel.centralsmashdown.game.control.*;
   import marvel.centralsmashdown.views.*;
   
   public class Main extends MovieClip
   {
      
      private static var instance:Main;
      
      public static var EVENT_NAV_CLICK:String = "navClick";
      
      public static var MENU_MODE_SCREEN:String = "screens";
      
      public static var MENU_MODE_GAME:String = "game";
       
      
      public var gameScreen:GameScreen;
      
      public var pl:Preloader;
      
      public var bottomNav:BottomNav;
      
      public var gameControl:GameControl;
      
      public var border:MovieClip;
      
      public var hulkHolder:MovieClip;
      
      public var loginScreen:MovieClip;
      
      public var sc:SoundCollection;
      
      private var _postLoginParams:*;
      
      public var isMuted:Boolean = false;
      
      public var debugBox:DebugBox;
      
      private var _so:SharedObject;
      
      public var contentHolder:MovieClip;
      
      public var outerFrame:OuterFrame;
      
      private var _postLoginMethod:Function;
      
      private var _initedParts:Boolean = false;
      
      public var debugMode:Boolean = false;
      
      public var preloadScreen:PreloadScreen;
      
      public var marvelUser:MarvelLoginUser;
      
      public function Main()
      {
         debugMode = false;
         isMuted = false;
         _initedParts = false;
         super();
         addFrameScript(0,frame1,23,frame24,34,frame35);
         if(instance)
         {
            throw new Error("Main is the document class and can only be accessed through Main.getInstance()");
         }
         instance = this;
      }
      
      public static function getInstance() : Main
      {
         return instance;
      }
      
      public function gotoGame(param1:String) : void
      {
         clearContent();
         gameControl.gameMode = param1;
         gotoAndStop("game");
      }
      
      private function goLink(param1:String, param2:String = "_blank") : void
      {
         var _loc3_:URLRequest = null;
         _loc3_ = new URLRequest(param1);
         navigateToURL(_loc3_,param2);
      }
      
      internal function frame1() : *
      {
         init();
         stop();
      }
      
      public function init() : void
      {
         var _loc1_:ContextMenu = null;
         var _loc2_:ContextMenuItem = null;
         var _loc3_:DebugBox = null;
         _loc1_ = new ContextMenu();
         _loc1_.hideBuiltInItems();
         _loc2_ = new ContextMenuItem("Visit Marvel Kids");
         _loc2_.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,contextOffSiteHandler);
         _loc1_.customItems.push(_loc2_);
         _loc2_ = new ContextMenuItem("Game by Soap Creative");
         _loc2_.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,contextSoapCreativeHandler);
         _loc1_.customItems.push(_loc2_);
         this.contextMenu = _loc1_;
         _loc3_ = DebugBox.getInstance();
         if(Config.DEBUG == true || this.loaderInfo.parameters.debug == "true")
         {
            debugMode = true;
            addChild(_loc3_);
         }
         FlashVars.init(this.root);
         if(FlashVars.data.userID != null && FlashVars.data.username != null && (FlashVars.data.countryID != null || FlashVars.data.country != null))
         {
            marvelUser = new MarvelLoginUser();
            marvelUser.userID = FlashVars.data.userID;
            marvelUser.username = FlashVars.data.username;
            marvelUser.country = FlashVars.data.countryID != null ? String(FlashVars.data.countryID) : String(FlashVars.data.country);
            DebugBox.debug("marveluser","data found " + marvelUser.userID + " " + marvelUser.username + " " + marvelUser.country);
         }
         else
         {
            DebugBox.debug("marveluser","no data found");
         }
         gameControl = GameControl.getInstance();
         getSo();
         setMute(false);
         initPreload();
      }
      
      public function initGame() : void
      {
         gameControl.registerScreens();
         gameControl.start();
         sc.fadeSound("s_soundtrack_game",0.5,0.25);
         sc.fadeSound("s_soundtrack_menu",0,0.25);
         bottomNav.menu = Main.MENU_MODE_GAME;
      }
      
      public function preloadOutHandler(param1:CustomEvent) : void
      {
         this.removeChild(preloadScreen);
         gotoScreens();
      }
      
      public function siteLoadErrorHandler(param1:Event) : void
      {
         trace("LOAD ERROR");
      }
      
      internal function frame35() : *
      {
         initGame();
      }
      
      public function initScreens() : void
      {
         if(_initedParts == false)
         {
            initParts();
            if(marvelUser == null)
            {
               showLogin(showContent,Config.NAV_MAINMENU);
            }
            else
            {
               showContent(Config.NAV_MAINMENU);
               bottomNav.gotoAndPlay("in");
            }
         }
         sc.fadeSound("s_soundtrack_menu",0.5,0.25);
         sc.fadeSound("s_soundtrack_game",0,0.25);
         outerFrame.gotoAndStop("gameName");
         outerFrame.yourBestArcade = gameControl.highScoreArcade;
         outerFrame.yourBestChallenge = gameControl.highScoreChallenge;
         DebugBox.setAtTop();
      }
      
      private function hideLogin() : void
      {
         loginScreen.removeEventListener(Config.LOGIN_SUCCESS,loginSuccessHandler);
         loginScreen.removeEventListener(Config.LOGIN_FAILED,loginFailedHandler);
         loginScreen.removeEventListener(Config.LOGIN_CLICK_SKIP,loginSkipHandler);
         loginScreen.removeEventListener(Config.LOGIN_CLICK_REGISTER,loginRegisterHandler);
         loginScreen.removeEventListener(Config.LOGIN_DONE,loginDoneHandler);
         if(_postLoginParams.length > 0)
         {
            _postLoginMethod(_postLoginParams);
         }
         else
         {
            _postLoginMethod();
         }
      }
      
      internal function frame24() : *
      {
         initScreens();
         stop();
      }
      
      public function clearContent() : void
      {
         var _loc1_:Number = NaN;
         _loc1_ = 0;
         while(_loc1_ < contentHolder.numChildren)
         {
            contentHolder.removeChildAt(_loc1_);
            _loc1_++;
         }
         if(hulkHolder.numChildren > 0)
         {
            hulkHolder.removeChildAt(0);
         }
      }
      
      public function contextSoapCreativeHandler(param1:ContextMenuEvent) : void
      {
         trace("contextSoapCreativeHandler");
         goLink(Config.SOAP_LINK);
      }
      
      public function gameOverHandler() : void
      {
         bottomNav.menu = Main.MENU_MODE_SCREEN;
         gotoScreens();
         if(marvelUser == null)
         {
            showLogin(showContent,Config.NAV_SUBMITSCORE);
         }
         else
         {
            showContent(Config.NAV_SUBMITSCORE);
         }
      }
      
      private function loginSuccessHandler(param1:CustomEvent) : void
      {
         marvelUser = param1.data.marvelUser;
      }
      
      public function getSo() : void
      {
         _so = SharedObject.getLocal("marvel-bad-altitude");
         if(_so.data.highScoreArcade != null)
         {
            gameControl.highScoreArcade = int(_so.data.highScoreArcade);
         }
         if(_so.data.highScoreChallenge != null)
         {
            gameControl.highScoreChallenge = int(_so.data.highScoreChallenge);
         }
      }
      
      private function showLogin(param1:Function, ... rest) : void
      {
         loginScreen = new LoginScreen();
         loginScreen.addEventListener(Config.LOGIN_SUCCESS,loginSuccessHandler);
         loginScreen.addEventListener(Config.LOGIN_FAILED,loginFailedHandler);
         loginScreen.addEventListener(Config.LOGIN_CLICK_SKIP,loginSkipHandler);
         loginScreen.addEventListener(Config.LOGIN_CLICK_REGISTER,loginRegisterHandler);
         loginScreen.addEventListener(Config.LOGIN_DONE,loginDoneHandler);
         clearContent();
         contentHolder.addChild(loginScreen);
         TweenLite.from(contentHolder,0.5,{"alpha":0});
         _postLoginMethod = param1;
         _postLoginParams = rest;
      }
      
      public function navClick(param1:CustomEvent) : *
      {
         switch(param1.data)
         {
            case Config.NAV_MUTE_TOGGLE:
               toggleMute();
               break;
            case Config.NAV_STARTGAME:
               showContent(param1.data);
               break;
            case Config.NAV_QUITMAIN_YES:
            case Config.NAV_HOWTOPLAY:
            case Config.NAV_HIGHSCORES:
            case Config.NAV_SENDTOFRIEND:
               gotoScreens();
               showContent(param1.data);
               break;
            case Config.NAV_MOREGAMES:
            case Config.NAV_MARVELLOGO:
               goLink("http://www.marvelkids.com");
         }
      }
      
      public function initParts() : void
      {
         _initedParts = true;
         border.mouseChildren = false;
         border.mouseEnabled = false;
         hulkHolder.mouseChildren = false;
         hulkHolder.mouseEnabled = false;
         bottomNav = outerFrame.bottomNav;
         bottomNav.init();
         bottomNav.addEventListener(Main.EVENT_NAV_CLICK,navClick);
         outerFrame.addEventListener(Main.EVENT_NAV_CLICK,navClick);
         addEventListener(Config.EVENT_MUTE_CHANGED,outerFrame.muteChangedHandler);
         sc = new SoundCollection();
         sc.addLinkedItem(s_soundtrack_menu);
         sc.addLinkedItem(s_soundtrack_game);
         sc.addLinkedItem(s_damage1);
         sc.addLinkedItem(s_damage2);
         sc.addLinkedItem(s_damage3);
         sc.addLinkedItem(s_damage4);
         sc.addLinkedItem(s_explosion1);
         sc.addLinkedItem(s_explosion2);
         sc.addLinkedItem(s_explosion3);
         sc.addLinkedItem(s_explosion4);
         sc.addLinkedItem(s_hulksmash1);
         sc.addLinkedItem(s_hulksmash2);
         sc.addLinkedItem(s_jump1);
         sc.addLinkedItem(s_jump2);
         sc.addLinkedItem(s_jump3);
         sc.addLinkedItem(s_jump4);
         sc.addLinkedItem(s_jump5);
         sc.addLinkedItem(s_jump6);
         sc.addLinkedItem(s_hitground);
         sc.addLinkedItem(s_mouseover);
         sc.addLinkedItem(s_mousedown);
         sc.play("s_soundtrack_menu",0,0,9999999999);
         sc.play("s_soundtrack_game",0,0,9999999999);
         sc.setVolume("s_soundtrack_game",0);
         sc.setVolume("s_soundtrack_menu",0.5);
      }
      
      public function gotoScreens() : void
      {
         gotoAndStop("screens");
      }
      
      public function siteLoadedHandler(param1:Event) : void
      {
         pl.removeEventListener(Event.COMPLETE,siteLoadedHandler);
         pl.removeEventListener(Config.EVENT_SITE_LOAD_ERROR,siteLoadErrorHandler);
         preloadScreen.goOut();
         Mochi.track(root,"f8b44225");
      }
      
      public function contextOffSiteHandler(param1:ContextMenuEvent) : void
      {
         trace("contextOffSiteHandler");
         goLink(Config.OFFICIAL_SITE_LINK);
      }
      
      private function setMute(param1:Boolean) : *
      {
         isMuted = param1;
         muteChangeHandler();
      }
      
      private function loginSkipHandler(param1:CustomEvent) : void
      {
         hideLogin();
      }
      
      public function set so(param1:Object) : void
      {
         var flushStatus:String = null;
         var obj:Object = param1;
         _so.data.highScoreArcade = obj.highScoreArcade;
         _so.data.highScoreChallenge = obj.highScoreChallenge;
         flushStatus = null;
         try
         {
            flushStatus = _so.flush(10000);
         }
         catch(error:Error)
         {
         }
      }
      
      private function loginRegisterHandler(param1:CustomEvent) : void
      {
         var _loc2_:* = null;
         _loc2_ = "javascript:loadSignup(\'" + FlashVars.data.ref + "\')";
         goLink(_loc2_,"_self");
      }
      
      private function toggleMute() : void
      {
         isMuted = !isMuted;
         muteChangeHandler();
      }
      
      private function loginFailedHandler(param1:CustomEvent) : void
      {
      }
      
      public function initPreload() : void
      {
         pl = new Preloader();
         pl.addItem(this);
         pl.startCheckPreload();
         pl.addEventListener(Event.COMPLETE,siteLoadedHandler);
         pl.addEventListener(Preloader.EVENT_SITE_LOAD_ERROR,siteLoadErrorHandler);
         pl.timer.addEventListener(TimerEvent.TIMER,preloadScreen.render);
         preloadScreen.addEventListener(Config.EVENT_SITE_LOADED,preloadOutHandler);
      }
      
      public function showContent(param1:String) : void
      {
         var _loc2_:Class = null;
         var _loc3_:* = undefined;
         var _loc4_:MovieClip = null;
         clearContent();
         switch(param1)
         {
            case Config.NAV_MAINMENU:
            case Config.NAV_QUITMAIN_YES:
               _loc2_ = MainMenu;
               _loc3_ = new Hulk();
               hulkHolder.addChild(_loc3_);
               bottomNav.menu = Main.MENU_MODE_SCREEN;
               break;
            case Config.NAV_HOWTOPLAY:
               _loc2_ = HowToPlay;
               break;
            case Config.NAV_HIGHSCORES:
               _loc2_ = HighScores;
               break;
            case Config.NAV_SENDTOFRIEND:
               _loc2_ = SendToFriend;
               break;
            case Config.NAV_STARTGAME:
               _loc2_ = ChooseGameMode;
               gotoScreens();
               break;
            case Config.NAV_SUBMITSCORE:
               _loc2_ = SubmitScore;
               gotoScreens();
         }
         if(_loc2_ != null)
         {
            _loc4_ = new _loc2_();
            contentHolder.addChild(_loc4_);
            _loc4_.removeEventListener(Main.EVENT_NAV_CLICK,navClick);
            _loc4_.addEventListener(Main.EVENT_NAV_CLICK,navClick);
            TweenLite.from(_loc4_,0.5,{"alpha":0});
         }
      }
      
      private function muteChangeHandler() : void
      {
         SoundMixer.soundTransform = new SoundTransform(isMuted == true ? 0 : Config.MAX_VOLUME);
         dispatchEvent(new CustomEvent(Config.EVENT_MUTE_CHANGED,isMuted));
      }
      
      private function loginDoneHandler(param1:CustomEvent) : void
      {
         hideLogin();
      }
   }
}
