package marvel.centralsmashdown.game.control
{
   public class GameCamera
   {
      
      public static var CAMERA_SCALE_CHANGE_RATE:Number = 0.02;
      
      public static var CAMERA_HEIGHT:int = 350;
      
      public static var CAMERA_X:int = 16;
      
      public static var CAMERA_GROUND_SPACER:Number = 105;
      
      public static var CAMERA_WIDTH:int = 700;
      
      public static var CAMERA_SCALE_TO_SPEED_RATIO:Number = 0.03;
      
      private static var instance:GameCamera = new GameCamera();
      
      public static var CAMERA_Y:int = 93;
       
      
      public var scale:Number;
      
      public var xOffset:Number = 0;
      
      public var yOffset:Number = 0;
      
      private var _minScale:Number;
      
      public var x:Number;
      
      public var y:Number;
      
      public function GameCamera()
      {
         xOffset = 0;
         yOffset = 0;
         super();
      }
      
      public static function getInstance() : GameCamera
      {
         return instance;
      }
      
      public function Camera() : *
      {
         if(instance)
         {
            throw new Error("GameCamera can only be accessed through GameCamera.getInstance()");
         }
      }
      
      public function calculate(param1:Number, param2:Number, param3:Number, param4:Number) : void
      {
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         _loc6_ = GameControl.GROUND_Y - param2;
         _loc7_ = Math.sqrt(Math.pow(param3,2) + Math.pow(param4,2));
         if(_loc6_ < 300 && param4 > 0)
         {
            _loc5_ = 1;
            scale += (_loc5_ - scale) * (GameCamera.CAMERA_SCALE_CHANGE_RATE * 2);
         }
         else
         {
            _loc5_ = 1 - GameCamera.CAMERA_SCALE_TO_SPEED_RATIO * _loc7_;
            scale += (_loc5_ - scale) * GameCamera.CAMERA_SCALE_CHANGE_RATE;
         }
         if(scale < _minScale)
         {
            scale = _minScale;
         }
         this.y = Math.round(-param2 + GameCamera.CAMERA_Y + GameCamera.CAMERA_HEIGHT / 2) * scale;
         this.x = Math.round(-param1 + GameCamera.CAMERA_X + GameCamera.CAMERA_WIDTH / 2) * scale;
         _loc8_ = GameCamera.CAMERA_X;
         _loc9_ = GameCamera.CAMERA_X - (GameControl.GAME_WIDTH * scale - GameCamera.CAMERA_WIDTH);
         _loc10_ = GameCamera.CAMERA_Y + GameCamera.CAMERA_HEIGHT - GameCamera.CAMERA_GROUND_SPACER * scale;
         if(this.x > _loc8_)
         {
            this.x = _loc8_;
         }
         if(this.x < _loc9_)
         {
            this.x = _loc9_;
         }
         if(this.y < _loc10_)
         {
            this.y = _loc10_;
         }
         this.x -= xOffset;
         this.y -= yOffset;
      }
      
      public function reset() : void
      {
         scale = 1;
         _minScale = GameCamera.CAMERA_WIDTH / GameControl.GAME_WIDTH;
      }
   }
}
