package marvel.centralsmashdown.game.views
{
   import com.gs.TweenFilterLite;
   import flash.display.MovieClip;
   import flash.events.*;
   import marvel.centralsmashdown.game.control.GameControl;
   
   public class GameOver extends MovieClip
   {
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
      
      private static var BUTTON_EVENT:String = "buttonEvent";
       
      
      private var _gameControl:GameControl;
      
      public var btnSubmitScore:MovieClip;
      
      public var txt:MovieClip;
      
      public var btnPlayAgain:MovieClip;
      
      public function GameOver()
      {
         super();
         _gameControl = GameControl.getInstance();
      }
      
      public function init() : void
      {
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_OVER,overHandler);
         btnSubmitScore.addEventListener(MouseEvent.MOUSE_OVER,overHandler);
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_OUT,outHandler);
         btnSubmitScore.addEventListener(MouseEvent.MOUSE_OUT,outHandler);
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_DOWN,downHandler);
         btnSubmitScore.addEventListener(MouseEvent.MOUSE_DOWN,downHandler);
         btnPlayAgain.buttonMode = true;
         btnSubmitScore.buttonMode = true;
         txt.hits.numHits.text = _gameControl.score.toString() + " HIT" + (_gameControl.score > 1 ? "S" : "") + "!";
      }
      
      public function outHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,GameOver.HIGHLIGHT_TWEENTIME,{
            "colorMatrixFilter":{"brightness":1},
            "glowFilter":{
               "color":13953073,
               "alpha":0,
               "blurX":6,
               "blurY":6,
               "strength":0,
               "quality":1
            }
         });
      }
      
      public function downHandler(param1:MouseEvent) : void
      {
         if(param1.target == btnPlayAgain)
         {
            _gameControl.start();
            this.parent.removeChild(this);
         }
         else
         {
            _gameControl.exit();
         }
      }
      
      public function set mode(param1:String) : void
      {
         switch(param1)
         {
            case GameControl.GAME_MODE_ARCADE:
               gotoAndStop(param1);
               break;
            case GameControl.GAME_MODE_CHALLENGE:
               gotoAndStop(param1);
               init();
         }
      }
      
      public function overHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,GameOver.HIGHLIGHT_TWEENTIME,{
            "colorMatrixFilter":{"brightness":1.25},
            "glowFilter":{
               "color":13953073,
               "alpha":0.5,
               "blurX":2,
               "blurY":2,
               "strength":1,
               "quality":1
            }
         });
      }
   }
}
