package marvel.centralsmashdown.game.views
{
   import com.gs.TweenLite;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.events.*;
   import flash.geom.ColorTransform;
   import flash.utils.Dictionary;
   import marvel.centralsmashdown.game.control.GameCamera;
   import marvel.centralsmashdown.game.control.GameControl;
   
   public class MiniMap extends MovieClip
   {
      
      private static var GAME_SHOW_WIDTH:Number = 900;
      
      private static var MINI_MAP_HEIGHT:Number = 113;
      
      private static var MINI_MAP_WIDTH:Number = 65;
      
      private static var GAME_SHOW_HEIGHT:Number = 700;
       
      
      private var _gameCamera:GameCamera;
      
      public var map:MovieClip;
      
      private var yScale:Number;
      
      public var _showing:Boolean;
      
      public var masker:MovieClip;
      
      private var _spriteList:Dictionary;
      
      private var xScale:Number;
      
      public var spriteHolder:MovieClip;
      
      public function MiniMap()
      {
         super();
         _spriteList = new Dictionary(true);
         _gameCamera = GameCamera.getInstance();
         spriteHolder = map.spriteHolder;
         xScale = MiniMap.MINI_MAP_WIDTH / MiniMap.GAME_SHOW_WIDTH;
         yScale = MiniMap.MINI_MAP_HEIGHT / MiniMap.GAME_SHOW_HEIGHT;
      }
      
      public function clearAll() : void
      {
         var _loc1_:Object = null;
         for(_loc1_ in _spriteList)
         {
            spriteDie(_spriteList[_loc1_]);
         }
      }
      
      public function set(param1:Sprite) : *
      {
         var index:int = 0;
         var mov:Sprite = param1;
         if(!_spriteList[mov])
         {
            createSprite(mov);
         }
         try
         {
            index = spriteHolder.getChildIndex(_spriteList[mov]);
         }
         catch(e:ArgumentError)
         {
            createSprite(mov);
         }
         _spriteList[mov].x = (mov.x * _gameCamera.scale + _gameCamera.x) * xScale;
         _spriteList[mov].y = (mov.y * _gameCamera.scale + _gameCamera.y) * yScale;
      }
      
      private function spriteDie(param1:MovieClip) : void
      {
         var sprite:MovieClip = param1;
         try
         {
            spriteHolder.removeChild(sprite);
         }
         catch(e:RangeError)
         {
            trace("cant find " + sprite.name);
         }
         catch(e:ArgumentError)
         {
            trace("cant find " + sprite.name);
         }
      }
      
      public function remove(param1:Sprite) : *
      {
         var sprite:MovieClip = null;
         var index:int = 0;
         var mov:Sprite = param1;
         if(_spriteList[mov])
         {
            sprite = _spriteList[mov];
            try
            {
               index = spriteHolder.getChildIndex(sprite);
               sprite = MovieClip(spriteHolder.getChildAt(index));
               TweenLite.to(sprite,0.5,{
                  "alpha":0,
                  "scaleX":2,
                  "scaleY":2,
                  "onComplete":spriteDie,
                  "onCompleteParams":[sprite]
               });
               delete _spriteList[mov];
            }
            catch(e:ArgumentError)
            {
            }
         }
      }
      
      public function set showing(param1:Boolean) : void
      {
         _showing = param1;
         this.play();
      }
      
      private function createSprite(param1:Sprite) : void
      {
         var _loc2_:MovieClip = null;
         var _loc3_:Number = NaN;
         var _loc4_:ColorTransform = null;
         _loc2_ = new MiniMapSprite();
         _loc3_ = param1 is Enemy || param1 is BonusSprite ? 0.25 : 1;
         if(param1 is BonusSprite)
         {
            if(BonusSprite(param1).types == GameControl.BONUS_TYPE_DOUBLEUP)
            {
               _loc4_ = new ColorTransform(1,5,50,1,0,0,0);
            }
            else
            {
               _loc4_ = new ColorTransform(1,50,5,1,0,0,0);
            }
            _loc2_.transform.colorTransform = _loc4_;
         }
         _loc2_.scaleX = _loc2_.scaleY = 2;
         _loc2_.alpha = 0;
         TweenLite.to(_loc2_,0.5,{
            "alpha":1,
            "scaleX":_loc3_,
            "scaleY":_loc3_
         });
         _spriteList[param1] = _loc2_;
         spriteHolder.addChild(_loc2_);
      }
   }
}
