package marvel.centralsmashdown.game.views
{
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.events.TimerEvent;
   import flash.geom.Matrix;
   import flash.utils.Timer;
   
   public class RumblePack extends Sprite
   {
      
      private static var START_ALPHA:Number = 0.6;
      
      private static var MAX_RUMBLE_DISTANCE:Number = 50;
      
      private static var TIMER_RATE:Number = 50;
       
      
      private var _rumbleAmt:Number;
      
      private var _bitmapData:BitmapData;
      
      private var _bitmap:Bitmap;
      
      private var _rumbleTimer:Timer;
      
      private var _srcMov:MovieClip;
      
      private var _alphaDecay:Number;
      
      private var _h:Number;
      
      private var _rumbleDecay:Number;
      
      private var _x:Number;
      
      private var _y:Number;
      
      private var _w:Number;
      
      public function RumblePack()
      {
         super();
      }
      
      public function create(param1:MovieClip, param2:Number, param3:Number, param4:Number, param5:Number) : void
      {
         _srcMov = param1;
         _w = param2;
         _h = param3;
         _x = param4;
         _y = param5;
         _bitmap = getBitmap();
         this.addChild(_bitmap);
         this.alpha = RumblePack.START_ALPHA;
         this.mouseEnabled = false;
         this.mouseChildren = false;
      }
      
      private function getBitmap() : Bitmap
      {
         var _loc1_:Matrix = null;
         var _loc2_:Bitmap = null;
         if(_bitmapData)
         {
            _bitmapData.dispose();
         }
         _bitmapData = new BitmapData(_w,_h,true,16777215);
         _loc1_ = new Matrix(1,0,0,1,_x,_y);
         _bitmapData.draw(_srcMov,_loc1_);
         return new Bitmap(_bitmapData);
      }
      
      private function die() : void
      {
         _rumbleTimer.removeEventListener(TimerEvent.TIMER,rumble);
         _rumbleTimer.stop();
         this.parent.removeChild(this);
      }
      
      private function rumble(param1:TimerEvent) : void
      {
         var e:TimerEvent = param1;
         _rumbleAmt -= _rumbleDecay;
         this.alpha -= _alphaDecay;
         if(_rumbleAmt <= 0)
         {
            die();
         }
         try
         {
            removeChild(_bitmap);
         }
         catch(e:Error)
         {
         }
         _bitmap = getBitmap();
         this.addChild(_bitmap);
         _bitmap.x = Math.random() * _rumbleAmt - _rumbleAmt / 2;
         _bitmap.y = Math.random() * _rumbleAmt - _rumbleAmt / 2;
      }
      
      public function startRumble(param1:Number, param2:Number) : void
      {
         _rumbleDecay = param1 / (param2 * 1000 / RumblePack.TIMER_RATE);
         _alphaDecay = 1 / (param2 * 1000 / RumblePack.TIMER_RATE);
         _rumbleAmt = param1;
         _rumbleTimer = new Timer(RumblePack.TIMER_RATE);
         _rumbleTimer.addEventListener(TimerEvent.TIMER,rumble);
         _rumbleTimer.start();
      }
   }
}
