package marvel.centralsmashdown.ui
{
   import com.gs.TweenLite;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.geom.Rectangle;
   import marvel.centralsmashdown.Config;
   import marvel.centralsmashdown.utils.FlagMaker;
   
   public class CountryDropDown extends MovieClip
   {
      
      public static var SCROLL_MIN_Y:Number = 1;
      
      public static var SCROLL_MAX_Y:Number = 87;
       
      
      private var _scrollHeight:Number;
      
      private var _countries:Array;
      
      private var _flagsSrc:Flags;
      
      public var selectedItem:CountryDropDownItem;
      
      private var _scrollIndex:int;
      
      public var scroller:MovieClip;
      
      public var list:MovieClip;
      
      private var _clicked:Boolean = false;
      
      public function CountryDropDown()
      {
         var _loc1_:* = undefined;
         _clicked = false;
         super();
         _countries = Config.COUNTRY_IDS;
         scroller = list.scroller;
         _flagsSrc = new Flags();
         _scrollHeight = CountryDropDown.SCROLL_MAX_Y - CountryDropDown.SCROLL_MIN_Y;
         selectedItem.addEventListener(MouseEvent.MOUSE_DOWN,mouseDownHandler);
         this.addEventListener(MouseEvent.MOUSE_OUT,mouseOutHandler);
         this.addEventListener(MouseEvent.MOUSE_OVER,mouseOverHandler);
         selectedItem.buttonMode = true;
         selectedItem.mouseEnabled = true;
         selectedItem.mouseChildren = false;
         scroller.buttonMode = true;
         _loc1_ = 1;
         while(_loc1_ < 6)
         {
            list["item" + _loc1_].buttonMode = true;
            list["item" + _loc1_].mouseChildren = false;
            list["item" + _loc1_].addEventListener(MouseEvent.MOUSE_DOWN,itemClickedHandler);
            list["item" + _loc1_].addEventListener(MouseEvent.MOUSE_OVER,itemOverHandler);
            list["item" + _loc1_].addEventListener(MouseEvent.MOUSE_OUT,itemOutHandler);
            _loc1_++;
         }
         scrollIndex = 0;
         setFlagItems();
         selectedMarvelCode = "1";
      }
      
      private function hideList() : void
      {
         TweenLite.to(list,0.5,{
            "y":225,
            "onComplete":function():*
            {
               _clicked = false;
            }
         });
         scroller.stopDrag();
         scroller.removeEventListener(MouseEvent.MOUSE_DOWN,scrollDownHandler);
         scroller.removeEventListener(MouseEvent.MOUSE_UP,scrollUpHandler);
         scroller.removeEventListener(MouseEvent.MOUSE_MOVE,scrollMoveHandler);
      }
      
      public function get selectedCountryCode() : String
      {
         return _countries[_scrollIndex].code;
      }
      
      public function get selectedMarvelCode() : String
      {
         return _countries[_scrollIndex].id;
      }
      
      public function set selectedCountryCode(param1:String) : void
      {
         var _loc2_:Number = NaN;
         _loc2_ = 0;
         while(_loc2_ < _countries.length)
         {
            if(_countries[_loc2_].code == param1)
            {
               selectedIndex = _loc2_;
               return;
            }
            _loc2_++;
         }
      }
      
      public function set scrollIndex(param1:int) : void
      {
         var _loc2_:Number = NaN;
         if(param1 >= _countries.length)
         {
            return;
         }
         _loc2_ = param1 / (_countries.length - 5);
         scroller.y = CountryDropDown.SCROLL_MIN_Y + _scrollHeight * _loc2_;
         _scrollIndex = param1;
         scrollMoveHandler(null);
      }
      
      private function itemClickedHandler(param1:MouseEvent) : void
      {
         scroller.stopDrag();
         selectedIndex = param1.target.index;
         _clicked = true;
         hideList();
      }
      
      private function scrollMoveHandler(param1:MouseEvent) : void
      {
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         _loc2_ = scroller.y - CountryDropDown.SCROLL_MIN_Y;
         _loc3_ = _loc2_ / _scrollHeight;
         if(_loc3_ > 1)
         {
            _loc3_ = 1;
         }
         _scrollIndex = Math.round(_loc3_ * (_countries.length - 5));
         setFlagItems();
      }
      
      public function set selectedMarvelCode(param1:String) : void
      {
         var _loc2_:Number = NaN;
         _loc2_ = 0;
         while(_loc2_ < _countries.length)
         {
            if(_countries[_loc2_].id == param1)
            {
               selectedIndex = _loc2_;
               return;
            }
            _loc2_++;
         }
      }
      
      private function scrollDownHandler(param1:MouseEvent) : void
      {
         scroller.startDrag(false,new Rectangle(221,CountryDropDown.SCROLL_MIN_Y,0,CountryDropDown.SCROLL_MAX_Y));
      }
      
      private function mouseDownHandler(param1:MouseEvent) : void
      {
         if(_clicked != true)
         {
            showList();
         }
      }
      
      public function setFlagItems() : void
      {
         var _loc1_:* = undefined;
         var _loc2_:int = 0;
         var _loc3_:FlagMaker = null;
         _loc1_ = 1;
         while(_loc1_ < 6)
         {
            _loc2_ = _scrollIndex + (_loc1_ - 1);
            _loc3_ = new FlagMaker(_flagsSrc,_countries[_loc2_].code);
            list["item" + _loc1_].setCountry(_countries[_loc2_].name,_loc3_,_loc2_);
            _loc1_++;
         }
      }
      
      private function mouseOutHandler(param1:MouseEvent) : void
      {
         hideList();
      }
      
      private function itemOutHandler(param1:MouseEvent) : void
      {
         param1.target.ro.alpha = 0;
      }
      
      private function itemOverHandler(param1:MouseEvent) : void
      {
         param1.target.ro.alpha = 0.5;
      }
      
      private function showList() : void
      {
         TweenLite.to(list,0.5,{"y":319});
         scroller.addEventListener(MouseEvent.MOUSE_DOWN,scrollDownHandler);
         scroller.addEventListener(MouseEvent.MOUSE_UP,scrollUpHandler);
         scroller.addEventListener(MouseEvent.MOUSE_MOVE,scrollMoveHandler);
         scrollMoveHandler(null);
      }
      
      private function scrollUpHandler(param1:MouseEvent) : void
      {
         scroller.stopDrag();
      }
      
      public function set selectedIndex(param1:int) : void
      {
         var _loc2_:FlagMaker = null;
         if(param1 >= _countries.length)
         {
            return;
         }
         _loc2_ = new FlagMaker(_flagsSrc,_countries[param1].code);
         selectedItem.setCountry(_countries[param1].name,_loc2_,param1);
         scrollIndex = param1;
      }
      
      private function mouseOverHandler(param1:MouseEvent) : void
      {
         if(_clicked != true)
         {
            showList();
         }
      }
   }
}
