package marvel.centralsmashdown.views
{
   import com.chris.AS3.events.HighScoreEvent;
   import com.chris.AS3.net.*;
   import com.chris.AS3.utils.TextUtil;
   import com.gs.TweenFilterLite;
   import com.markdavies.control.ButtonSet;
   import com.markdavies.events.CustomEvent;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.geom.*;
   import marvel.centralsmashdown.*;
   import marvel.centralsmashdown.game.control.GameControl;
   import marvel.centralsmashdown.utils.FlagMaker;
   
   public class HighScores extends MovieClip
   {
      
      private static var NEXT:String = "next";
      
      private static var PREVIOUS:String = "previous";
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
       
      
      public var btnArrowRight:MovieClip;
      
      public var rankItems:MovieClip;
      
      private var _flagsSrc:Flags;
      
      private var _gameControl:GameControl;
      
      private var _hsLoader:HighScoreLoader;
      
      public var btnChallenge:MovieClip;
      
      private var _hsList:HighScoreList;
      
      private var _main:Main;
      
      private var _fieldNum:Number = 10;
      
      public var btnArcade:MovieClip;
      
      public var btnArrowLeft:MovieClip;
      
      private var _bs:ButtonSet;
      
      public function HighScores()
      {
         _fieldNum = 10;
         super();
         init();
      }
      
      private function arrowClick(param1:Event) : void
      {
         if(param1.type == "next")
         {
            if(_hsList.page == _hsList.maxPages)
            {
               _hsList.start();
            }
            else
            {
               _hsList.next();
            }
         }
         else if(_hsList.page == 0)
         {
            _hsList.last();
         }
         else
         {
            _hsList.prev();
         }
         _main.sc.play("s_mousedown",0.25);
      }
      
      private function updateList(param1:HighScoreEvent) : void
      {
         var _loc2_:String = null;
         var _loc3_:int = 0;
         var _loc4_:int = 0;
         var _loc5_:MovieClip = null;
         var _loc6_:XML = null;
         var _loc7_:FlagMaker = null;
         _loc3_ = 0;
         while(_loc3_ < _fieldNum)
         {
            _loc4_ = param1.first + _loc3_;
            (_loc5_ = rankItems["r" + (_loc3_ + 1)]).visible = _loc4_ < param1.end;
            if(_loc5_.visible)
            {
               _loc6_ = _hsLoader.getScoreXML(_loc4_);
               _loc5_.txt.rankTxt.text = (param1.first + _loc3_ + 1).toString();
               _loc5_.txt.nameTxt.text = _loc6_.@pname.toUpperCase();
               _loc5_.txt.scoreTxt.text = TextUtil.formatScoreComma(_loc6_.@score);
               _loc2_ = _loc6_.@miscellaneous1;
               _loc7_ = new FlagMaker(_flagsSrc,_loc2_);
               _loc5_.flag.addChild(_loc7_);
            }
            _loc3_++;
         }
         gotoAndStop("show");
      }
      
      public function init() : void
      {
         var _loc1_:int = 0;
         _main = Main.getInstance();
         _gameControl = GameControl.getInstance();
         _bs = new ButtonSet();
         _bs.addButton(btnArrowLeft,buttonOverHandler,arrowClick,buttonOutHandler,new CustomEvent(HighScores.PREVIOUS,{"target":btnArrowLeft}));
         _bs.addButton(btnArrowRight,buttonOverHandler,arrowClick,buttonOutHandler,new CustomEvent(HighScores.NEXT,{"target":btnArrowRight}));
         _loc1_ = _gameControl.gameMode == GameControl.GAME_MODE_ARCADE ? int(Config.HIGH_SCORE_ID_ARCADE) : int(Config.HIGH_SCORE_ID_CHALLENGE);
         loadScores(_loc1_);
         rankItems.mouseEnabled = false;
         rankItems.mouseChildren = false;
         _flagsSrc = new Flags();
         _gameControl = GameControl.getInstance();
      }
      
      public function buttonOverHandler(param1:CustomEvent) : void
      {
         var _loc2_:MovieClip = null;
         _loc2_ = param1.data.target;
         TweenFilterLite.to(_loc2_.base,HighScores.HIGHLIGHT_TWEENTIME,{"alpha":1});
         _main.sc.play("s_mouseover",0.25);
      }
      
      private function downHandler(param1:MouseEvent) : void
      {
         _main.sc.play("s_mousedown",0.25);
         switch(param1.target)
         {
            case btnChallenge:
               loadScores(Config.HIGH_SCORE_ID_CHALLENGE);
               break;
            case btnArcade:
               loadScores(Config.HIGH_SCORE_ID_ARCADE);
         }
      }
      
      private function enableButton(param1:MovieClip, param2:Boolean) : void
      {
         var _loc3_:Function = null;
         _loc3_ = param2 == true ? param1.addEventListener : param1.removeEventListener;
         _loc3_(MouseEvent.MOUSE_OVER,overHandler);
         _loc3_(MouseEvent.MOUSE_DOWN,downHandler);
         param1.mouseChildren = param2;
         param1.mouseEnabled = param2;
         param1.buttonMode = param2;
         param1.gotoAndStop(param2 == true ? "off" : "on");
      }
      
      private function loadScores(param1:int) : void
      {
         _hsLoader = new HighScoreLoader();
         _hsList = new HighScoreList();
         _hsLoader.addEventListener(Event.COMPLETE,scoresLoaded);
         _hsLoader.loadScores(param1);
         switch(param1)
         {
            case Config.HIGH_SCORE_ID_ARCADE:
               enableButton(btnChallenge,true);
               enableButton(btnArcade,false);
               break;
            case Config.HIGH_SCORE_ID_CHALLENGE:
               enableButton(btnArcade,true);
               enableButton(btnChallenge,false);
         }
         gotoAndStop("loading");
      }
      
      private function scoresLoaded(param1:Event) : void
      {
         _hsList.addEventListener(HighScoreEvent.CHANGE,updateList);
         _hsList.init(_fieldNum,_hsLoader.scoresNum);
      }
      
      private function overHandler(param1:MouseEvent) : void
      {
         _main.sc.play("s_mouseover",0.25);
      }
      
      public function buttonOutHandler(param1:CustomEvent) : void
      {
         var _loc2_:MovieClip = null;
         _loc2_ = param1.data.target;
         TweenFilterLite.to(_loc2_.base,HighScores.HIGHLIGHT_TWEENTIME,{"alpha":0});
      }
   }
}
