package marvel.centralsmashdown.views
{
   import com.gs.TweenFilterLite;
   import com.markdavies.control.ButtonSet;
   import com.markdavies.events.CustomEvent;
   import com.soap.net.MarvelLoginConnector;
   import com.soap.net.MarvelLoginUser;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.text.TextField;
   import flash.utils.Timer;
   import marvel.centralsmashdown.Config;
   import marvel.centralsmashdown.Main;
   
   public class LoginScreen extends MovieClip
   {
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
      
      private static var BUTTON_EVENT:String = "buttonEvent";
       
      
      public var btnRegister:MovieClip;
      
      public var arrow1:MovieClip;
      
      public var arrow2:MovieClip;
      
      public var btnLogin:MovieClip;
      
      private var _marvelConnector:MarvelLoginConnector;
      
      public var btnSkip:MovieClip;
      
      private var _marvelUser:MarvelLoginUser;
      
      public var userNameTxt:TextField;
      
      private var _main:Main;
      
      private var _timer:Timer;
      
      public var passwordTxt:TextField;
      
      private var _bs:ButtonSet;
      
      public function LoginScreen()
      {
         super();
         _main = Main.getInstance();
      }
      
      public function init() : void
      {
         _bs = new ButtonSet();
         _bs.addButton(btnSkip,overHandler,skipClickHandler,outHandler,new CustomEvent(LoginScreen.BUTTON_EVENT,{"target":btnSkip}));
         _bs.addButton(btnRegister,overHandler,registerClickHandler,outHandler,new CustomEvent(LoginScreen.BUTTON_EVENT,{"target":btnRegister}));
         _bs.addButton(btnLogin,overHandler,loginClickHandler,outHandler,new CustomEvent(LoginScreen.BUTTON_EVENT,{"target":btnLogin}));
      }
      
      public function outHandler(param1:CustomEvent) : void
      {
         TweenFilterLite.to(param1.data.target,LoginScreen.HIGHLIGHT_TWEENTIME,{
            "colorMatrixFilter":{"brightness":1},
            "glowFilter":{
               "color":13953073,
               "alpha":0,
               "blurX":6,
               "blurY":6,
               "strength":0,
               "quality":1
            }
         });
      }
      
      private function loginFailHandler(param1:CustomEvent) : void
      {
         gotoAndStop("loginFailed");
         _timer = new Timer(3000,1);
         _timer.addEventListener(TimerEvent.TIMER,failOutHandler);
         _timer.removeEventListener(TimerEvent.TIMER,successOutHandler);
         _timer.start();
      }
      
      private function validate() : Boolean
      {
         var _loc1_:Boolean = false;
         _loc1_ = false;
         if(userNameTxt.text == "")
         {
            _loc1_ = true;
            arrow1.alpha = 1;
         }
         else
         {
            arrow1.alpha = 0;
         }
         if(passwordTxt.text == "")
         {
            _loc1_ = true;
            arrow2.alpha = 1;
         }
         else
         {
            arrow2.alpha = 0;
         }
         return !_loc1_;
      }
      
      private function loginSuccessHandler(param1:CustomEvent) : void
      {
         gotoAndStop("loggedIn");
         dispatchEvent(new CustomEvent(Config.LOGIN_SUCCESS,{"marvelUser":_marvelConnector.marvelUser}));
         _timer = new Timer(3000,1);
         _timer.removeEventListener(TimerEvent.TIMER,failOutHandler);
         _timer.addEventListener(TimerEvent.TIMER,successOutHandler);
         _timer.start();
      }
      
      private function successOutHandler(param1:TimerEvent) : void
      {
         dispatchEvent(new CustomEvent(Config.LOGIN_DONE));
      }
      
      public function loginClickHandler(param1:CustomEvent) : void
      {
         if(validate() == false)
         {
            return;
         }
         _marvelConnector = new MarvelLoginConnector();
         _marvelConnector.login(userNameTxt.text,passwordTxt.text);
         _marvelConnector.addEventListener(MarvelLoginConnector.EVENT_LOGIN_SUCCESS,loginSuccessHandler,false,0,true);
         _marvelConnector.addEventListener(MarvelLoginConnector.EVENT_LOGIN_FAILED,loginFailHandler,false,0,true);
         _main.sc.play("s_mousedown",0.25);
         gotoAndStop("loggingIn");
      }
      
      public function skipClickHandler(param1:CustomEvent) : void
      {
         dispatchEvent(new CustomEvent(Config.LOGIN_CLICK_SKIP));
         _main.sc.play("s_mousedown",0.25);
      }
      
      public function overHandler(param1:CustomEvent) : void
      {
         TweenFilterLite.to(param1.data.target,LoginScreen.HIGHLIGHT_TWEENTIME,{
            "colorMatrixFilter":{"brightness":1.25},
            "glowFilter":{
               "color":13953073,
               "alpha":0.5,
               "blurX":2,
               "blurY":2,
               "strength":1,
               "quality":1
            }
         });
         _main.sc.play("s_mouseover",0.25);
      }
      
      private function failOutHandler(param1:TimerEvent) : void
      {
         gotoAndStop("login");
      }
      
      public function registerClickHandler(param1:CustomEvent) : void
      {
         dispatchEvent(new CustomEvent(Config.LOGIN_CLICK_REGISTER));
         _main.sc.play("s_mousedown",0.25);
      }
   }
}
