package marvel.centralsmashdown.views
{
   import com.chris.AS3.utils.TextUtil;
   import com.gs.TweenFilterLite;
   import com.gs.TweenLite;
   import com.markdavies.debug.DebugBox;
   import com.markdavies.events.CustomEvent;
   import fl.transitions.easing.*;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.text.TextField;
   import flash.utils.Timer;
   import marvel.centralsmashdown.*;
   import marvel.centralsmashdown.game.control.GameControl;
   
   public class OuterFrame extends MovieClip
   {
      
      private static var REFRESH_RATE:int = 10;
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
      
      private static var SCORE_INC_RATE:Number = 0.05;
       
      
      public var timeBar:MovieClip;
      
      private var _gameControl:GameControl;
      
      public var timeTxt:TextField;
      
      private var _currentScore:int;
      
      private var _timer:Timer;
      
      public var miniMap:MiniMap;
      
      private var _aimScore:int;
      
      public var scoreTxt:TextField;
      
      public var muteButton:MovieClip;
      
      public var marvelLogo:MovieClip;
      
      public var yourBestMov:MovieClip;
      
      public function OuterFrame()
      {
         super();
         init();
      }
      
      public function set yourBestChallenge(param1:int) : void
      {
         yourBestMov.challenge.txt.text = TextUtil.formatScoreComma(param1);
      }
      
      public function init() : void
      {
         TweenLite.from(marvelLogo,1,{
            "scaleX":0.1,
            "scaleY":0.1,
            "ease":Elastic.easeOut
         });
         try
         {
            _timer.running;
         }
         catch(e:TypeError)
         {
            _timer = new Timer(OuterFrame.REFRESH_RATE);
            _timer.addEventListener(TimerEvent.TIMER,render);
         }
         _timer.start();
         muteButton.addEventListener(MouseEvent.MOUSE_DOWN,muteButtonClickHandler);
         muteButton.buttonMode = true;
         marvelLogo.addEventListener(MouseEvent.MOUSE_DOWN,marvelLogoClickHandler);
         marvelLogo.addEventListener(MouseEvent.MOUSE_OVER,marvelLogoOverHandler);
         marvelLogo.addEventListener(MouseEvent.MOUSE_OUT,marvelLogoOutHandler);
         marvelLogo.buttonMode = true;
         _gameControl = GameControl.getInstance();
      }
      
      public function set score(param1:int) : void
      {
         _aimScore = param1;
         DebugBox.debug("_aimScore",_aimScore);
      }
      
      public function set yourBestArcade(param1:int) : void
      {
         yourBestMov.arcade.txt.text = TextUtil.formatScoreComma(param1);
      }
      
      public function set scoreHardChange(param1:int) : void
      {
         _aimScore = param1;
         _currentScore = param1;
      }
      
      public function set gameMode(param1:String) : void
      {
         switch(param1)
         {
            case GameControl.GAME_MODE_ARCADE:
               gotoAndStop(param1);
               break;
            case GameControl.GAME_MODE_CHALLENGE:
               gotoAndStop(param1);
         }
      }
      
      public function muteChangedHandler(param1:CustomEvent) : void
      {
         if(param1.data == true)
         {
            muteButton.gotoAndStop("off");
         }
         else
         {
            muteButton.gotoAndPlay("on");
         }
      }
      
      private function marvelLogoOutHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,0.3,{"glowFilter":{
            "color":3407616,
            "alpha":0,
            "blurX":10,
            "blurY":10
         }});
      }
      
      public function set timeRemaining(param1:int) : void
      {
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         var _loc5_:String = null;
         var _loc6_:String = null;
         var _loc7_:String = null;
         if(param1 < 0)
         {
            param1 = 0;
         }
         _loc2_ = Math.floor(param1 / 60000);
         _loc3_ = Math.floor((param1 - _loc2_ * 60000) / 1000);
         _loc4_ = Math.round((param1 - _loc2_ * 60000 - _loc3_ * 1000) / 10);
         _loc5_ = _loc2_.toString();
         _loc6_ = _loc3_.toString();
         _loc7_ = _loc4_.toString();
         if(_loc5_.length == 1)
         {
            _loc5_ = "0" + _loc5_;
         }
         if(_loc6_.length == 1)
         {
            _loc6_ = "0" + _loc6_;
         }
         if(_loc7_.length == 1)
         {
            _loc7_ = "0" + _loc7_;
         }
         timeTxt.text = _loc5_ + ":" + _loc6_ + ":" + _loc7_;
      }
      
      public function set timePercentage(param1:Number) : void
      {
         if(param1 > 1)
         {
            param1 = 1;
         }
         timeBar.bar.scaleX = param1;
      }
      
      private function marvelLogoOverHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,0.3,{"glowFilter":{
            "color":3407616,
            "alpha":0.7,
            "blurX":10,
            "blurY":10
         }});
      }
      
      private function marvelLogoClickHandler(param1:MouseEvent) : void
      {
         dispatchEvent(new CustomEvent(Main.EVENT_NAV_CLICK,Config.NAV_MARVELLOGO));
      }
      
      private function render(param1:TimerEvent) : void
      {
         var _loc2_:int = 0;
         if(_currentScore == _aimScore)
         {
            return;
         }
         _loc2_ = _aimScore - _currentScore > 10 ? 10 : 1;
         _currentScore += _currentScore > _aimScore ? -1 * _loc2_ : 1 * _loc2_;
         scoreTxt.text = TextUtil.formatScoreComma(_currentScore);
         DebugBox.debug("_currentScore",_currentScore);
      }
      
      private function muteButtonClickHandler(param1:MouseEvent) : void
      {
         dispatchEvent(new CustomEvent(Main.EVENT_NAV_CLICK,Config.NAV_MUTE_TOGGLE));
      }
   }
}
