package marvel.centralsmashdown.views
{
   import com.gs.TweenFilterLite;
   import com.gs.TweenLite;
   import com.markdavies.debug.DebugBox;
   import com.markdavies.utils.Validator;
   import fl.motion.easing.*;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.net.*;
   import flash.text.TextField;
   import flash.utils.Timer;
   import marvel.centralsmashdown.Main;
   import marvel.centralsmashdown.game.control.GameControl;
   
   public class SendToFriend extends MovieClip
   {
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
      
      public static var STF_URL:String = "http://stats.soap.com.au/stats08/hulk_game2_challenge.php";
       
      
      public var recipEmailArrow:MovieClip;
      
      private var loader:URLLoader;
      
      public var recipEmail:TextField;
      
      private var _gameControl:GameControl;
      
      public var recipNameArrow:MovieClip;
      
      public var senderEmail:TextField;
      
      private var _timer:Timer;
      
      public var senderNameArrow:MovieClip;
      
      public var senderName:TextField;
      
      private var _buttonDown:Boolean;
      
      private var _main:Main;
      
      private var request:URLRequest;
      
      private var sendVariables:URLVariables;
      
      public var sendButton:MovieClip;
      
      public var recipName:TextField;
      
      public var senderEmailArrow:MovieClip;
      
      public function SendToFriend()
      {
         super();
         _gameControl = GameControl.getInstance();
         _buttonDown = false;
         loader = new URLLoader();
         loader.dataFormat = URLLoaderDataFormat.VARIABLES;
         request = new URLRequest(SendToFriend.STF_URL);
         loader.addEventListener(Event.COMPLETE,onComplete,false);
         loader.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler,false);
         loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR,securityErrorHandler,false);
         registerListeners(true);
         senderNameArrow.alpha = 0;
         recipNameArrow.alpha = 0;
         senderEmailArrow.alpha = 0;
         recipEmailArrow.alpha = 0;
         showSendButton = true;
         _main = Main.getInstance();
      }
      
      private function registerListeners(param1:Boolean) : *
      {
         var _loc2_:Function = null;
         _loc2_ = param1 == true ? sendButton.btn.addEventListener : sendButton.btn.removeEventListener;
         _loc2_(MouseEvent.MOUSE_DOWN,sendClickHandler);
         _loc2_(MouseEvent.MOUSE_OVER,sendOverHandler);
         _loc2_(MouseEvent.MOUSE_OUT,sendOutHandler);
         sendButton.btn.mouseEnabled = param1;
         sendButton.btn.buttonMode = param1;
         TweenFilterLite.to(sendButton.btn,SendToFriend.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":0,
               "blurX":2,
               "blurY":2,
               "strength":0,
               "quality":1
            },
            "alpha":0
         });
      }
      
      private function sendOverHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SendToFriend.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":1,
               "blurX":20,
               "blurY":20,
               "strength":5,
               "quality":1
            },
            "alpha":0.25
         });
         _main.sc.play("s_mouseover",0.25);
      }
      
      private function onComplete(param1:Event) : void
      {
         var _loc2_:String = null;
         _loc2_ = String(loader.data);
         if(_loc2_.indexOf("sent=true") != -1)
         {
            gotoAndStop("success");
         }
         else
         {
            gotoAndStop("error");
            timerBackToForm();
         }
      }
      
      private function validate() : Boolean
      {
         var _loc1_:Boolean = false;
         var _loc2_:Boolean = false;
         var _loc3_:Validator = null;
         _loc1_ = false;
         _loc3_ = new Validator();
         _loc2_ = _loc3_.validate(Validator.TYPE_EMAIL,senderEmail.text);
         _loc1_ = _loc2_ == true ? true : _loc1_;
         senderEmailArrow.alpha = int(_loc2_);
         _loc2_ = _loc3_.validate(Validator.TYPE_EMAIL,recipEmail.text);
         _loc1_ = _loc2_ == true ? true : _loc1_;
         recipEmailArrow.alpha = int(_loc2_);
         _loc2_ = _loc3_.validate(Validator.TYPE_STRING,senderName.text);
         _loc1_ = _loc2_ == true ? true : _loc1_;
         senderNameArrow.alpha = int(_loc2_);
         _loc2_ = _loc3_.validate(Validator.TYPE_STRING,recipName.text);
         _loc1_ = _loc2_ == true ? true : _loc1_;
         recipNameArrow.alpha = int(_loc2_);
         return !_loc1_;
      }
      
      private function set showSendButton(param1:Boolean) : void
      {
         if(param1 == true)
         {
            TweenLite.to(sendButton,1,{
               "y":70,
               "ease":Elastic.easeOut
            });
            _buttonDown = true;
         }
         else
         {
            TweenLite.to(sendButton,0.25,{
               "y":-450,
               "ease":Linear.easeIn
            });
            _buttonDown = false;
         }
      }
      
      private function sendClickHandler(param1:MouseEvent) : void
      {
         _main.sc.play("s_mousedown",0.25);
         send();
      }
      
      private function ioErrorHandler(param1:IOErrorEvent) : void
      {
         DebugBox.debug("stf","ioErrorHandler");
         gotoAndStop("error");
         timerBackToForm();
      }
      
      private function securityErrorHandler(param1:SecurityErrorEvent) : void
      {
         DebugBox.debug("stf","securityErrorHandler");
         gotoAndStop("error");
         timerBackToForm();
      }
      
      private function send() : void
      {
         if(validate() == false)
         {
            return;
         }
         showSendButton = false;
         registerListeners(false);
         sendVariables = new URLVariables();
         sendVariables.strName = senderName.text;
         sendVariables.strEmail = senderEmail.text;
         sendVariables.F_name_1 = recipName.text;
         sendVariables.F_email_1 = recipEmail.text;
         sendVariables.intScore = _gameControl.highScore;
         request.data = sendVariables;
         request.method = "POST";
         DebugBox.debug("stf","sending " + senderEmail.text + " " + recipEmail.text);
         try
         {
            loader.load(request);
            gotoAndStop("sending");
         }
         catch(error:Error)
         {
            gotoAndStop("error");
            timerBackToForm();
         }
      }
      
      private function timerBackToForm() : void
      {
         _timer = new Timer(3000,1);
         _timer.addEventListener(TimerEvent.TIMER,toForm);
         _timer.start();
      }
      
      private function toForm(param1:TimerEvent) : void
      {
         registerListeners(true);
         showSendButton = true;
         gotoAndStop("form");
      }
      
      private function sendOutHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SendToFriend.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":0,
               "blurX":2,
               "blurY":2,
               "strength":0,
               "quality":1
            },
            "alpha":0
         });
      }
   }
}
