package marvel.centralsmashdown.views
{
   import com.chris.AS3.utils.TextUtil;
   import com.gs.TweenFilterLite;
   import com.gs.TweenLite;
   import com.markdavies.debug.DebugBox;
   import com.markdavies.events.CustomEvent;
   import fl.motion.easing.*;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.net.*;
   import flash.text.TextField;
   import flash.utils.Timer;
   import marvel.centralsmashdown.Config;
   import marvel.centralsmashdown.Main;
   import marvel.centralsmashdown.game.control.GameControl;
   
   public class SubmitScore extends MovieClip
   {
      
      public static var HIGHSCORES_URL:String = "http://stats.soap.com.au/highscore/engine_mofo.php";
      
      private static var HIGHLIGHT_TWEENTIME:Number = 0.25;
       
      
      public var yourInitials:TextField;
      
      private var loader:URLLoader;
      
      private var _gameControl:GameControl;
      
      private var _timer:Timer;
      
      public var btnPlayAgain:MovieClip;
      
      private var _main:Main;
      
      private var request:URLRequest;
      
      public var scoreTxt:TextField;
      
      private var sendVariables:URLVariables;
      
      public var sendButton:MovieClip;
      
      public var countryDropDown:CountryDropDown;
      
      public function SubmitScore()
      {
         super();
         _gameControl = GameControl.getInstance();
         _main = Main.getInstance();
         if(_main.marvelUser != null)
         {
            countryDropDown.selectedMarvelCode = _main.marvelUser.country;
            yourInitials.text = _main.marvelUser.username;
            TweenLite.from(sendButton,1,{
               "y":-270,
               "ease":Elastic.easeOut,
               "delay":0.5
            });
            registerListeners(true);
            yourInitials.addEventListener(Event.CHANGE,textChangeHandler);
            loader = new URLLoader();
            loader.dataFormat = URLLoaderDataFormat.VARIABLES;
            request = new URLRequest(SubmitScore.HIGHSCORES_URL);
            loader.addEventListener(Event.COMPLETE,onComplete,false);
            loader.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler,false);
            loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR,securityErrorHandler,false);
         }
         else
         {
            sendButton.y = -270;
            gotoAndStop("nosubmit");
         }
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_DOWN,playClickHandler);
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_OVER,playOverHandler);
         btnPlayAgain.addEventListener(MouseEvent.MOUSE_OUT,playOutHandler);
         btnPlayAgain.buttonMode = true;
         scoreTxt.text = TextUtil.formatScoreComma(_gameControl.lastScore);
      }
      
      private function timerToHighscores() : void
      {
         _timer = new Timer(2000,1);
         _timer.addEventListener(TimerEvent.TIMER,toHighScores);
         _timer.start();
      }
      
      private function registerListeners(param1:Boolean) : *
      {
         var _loc2_:Function = null;
         _loc2_ = param1 == true ? sendButton.btn.addEventListener : sendButton.btn.removeEventListener;
         _loc2_(MouseEvent.MOUSE_DOWN,sendClickHandler);
         _loc2_(MouseEvent.MOUSE_OVER,sendOverHandler);
         _loc2_(MouseEvent.MOUSE_OUT,sendOutHandler);
         sendButton.btn.mouseEnabled = param1;
         sendButton.btn.buttonMode = param1;
         TweenFilterLite.to(sendButton.btn,SubmitScore.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":0,
               "blurX":2,
               "blurY":2,
               "strength":0,
               "quality":1
            },
            "alpha":0
         });
      }
      
      private function sendOverHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SubmitScore.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":1,
               "blurX":20,
               "blurY":20,
               "strength":5,
               "quality":1
            },
            "alpha":0.25
         });
      }
      
      private function playOverHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SubmitScore.HIGHLIGHT_TWEENTIME,{"glowFilter":{
            "color":13953073,
            "alpha":0.5,
            "blurX":2,
            "blurY":2,
            "strength":1,
            "quality":1
         }});
         _main.sc.play("s_mouseover",0.25);
      }
      
      private function toHighScores(param1:TimerEvent) : void
      {
         registerListeners(false);
         _main.showContent(Config.NAV_HIGHSCORES);
      }
      
      private function onComplete(param1:Event) : void
      {
         var _loc2_:String = null;
         _loc2_ = String(loader.data);
         if(_loc2_.indexOf("result=yes") != -1)
         {
            gotoAndStop("success");
            timerToHighscores();
         }
         else
         {
            gotoAndStop("error");
            timerBackToForm();
         }
      }
      
      private function playOutHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SubmitScore.HIGHLIGHT_TWEENTIME,{"glowFilter":{
            "color":13953073,
            "alpha":0,
            "blurX":2,
            "blurY":2,
            "strength":1,
            "quality":1
         }});
      }
      
      private function sendClickHandler(param1:MouseEvent) : void
      {
         send();
      }
      
      private function ioErrorHandler(param1:IOErrorEvent) : void
      {
         trace("ioErrorHandler");
         DebugBox.debug("submitscore","ioErrorHandler");
         gotoAndStop("error");
         timerBackToForm();
      }
      
      private function securityErrorHandler(param1:SecurityErrorEvent) : void
      {
         trace("securityErrorHandler");
         DebugBox.debug("submitscore","securityErrorHandler");
         gotoAndStop("error");
         timerBackToForm();
      }
      
      private function send() : void
      {
         registerListeners(false);
         sendVariables = new URLVariables();
         sendVariables.intGameId = _gameControl.gameMode == GameControl.GAME_MODE_ARCADE ? Config.HIGH_SCORE_ID_ARCADE : Config.HIGH_SCORE_ID_CHALLENGE;
         sendVariables.strName = _main.marvelUser.username;
         sendVariables.strEmail = Math.round(Math.random() * 1000000000000000).toString() + "@" + Math.round(Math.random() * 1000000000000000).toString() + ".com";
         sendVariables.intScore = _gameControl.lastScore;
         sendVariables.strMisc1 = countryDropDown.selectedCountryCode;
         if(_main.marvelUser != null)
         {
            sendVariables.strMisc4 = _main.marvelUser.userID;
         }
         request.data = sendVariables;
         request.method = "POST";
         DebugBox.debug("submitscore","send to " + SubmitScore.HIGHSCORES_URL);
         try
         {
            loader.load(request);
            gotoAndStop("sending");
         }
         catch(error:Error)
         {
            gotoAndStop("error");
            timerBackToForm();
         }
         DebugBox.setAtTop();
      }
      
      private function textChangeHandler(param1:Event) : void
      {
         yourInitials.text = yourInitials.text.toUpperCase();
      }
      
      private function timerBackToForm() : void
      {
         _timer = new Timer(3000,1);
         _timer.addEventListener(TimerEvent.TIMER,toForm);
         _timer.start();
      }
      
      private function sendOutHandler(param1:MouseEvent) : void
      {
         TweenFilterLite.to(param1.target,SubmitScore.HIGHLIGHT_TWEENTIME,{
            "glowFilter":{
               "color":15537941,
               "alpha":0,
               "blurX":2,
               "blurY":2,
               "strength":0,
               "quality":1
            },
            "alpha":0
         });
      }
      
      private function toForm(param1:TimerEvent) : void
      {
         registerListeners(false);
         gotoAndStop("form");
      }
      
      private function playClickHandler(param1:MouseEvent) : void
      {
         _main.sc.play("s_mousedown",0.25);
         dispatchEvent(new CustomEvent(Main.EVENT_NAV_CLICK,Config.NAV_STARTGAME));
      }
   }
}
